Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1627803 - All pushes to git repository fail
Summary: All pushes to git repository fail
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: hg-git
Version: 28
Hardware: All
OS: Linux
unspecified
high
Target Milestone: ---
Assignee: Petr Stodulka
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-09-11 13:53 UTC by Robert Vazan
Modified: 2018-09-27 02:33 UTC (History)
3 users (show)

Fixed In Version: hg-git-0.8.11-2.fc28, hg-git-0.8.11-3.fc29, hg-git-0.8.11-3.fc30 hg-git-0.8.11-3.fc29 hg-git-0.8.11-2.fc28
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-09-26 20:20:08 UTC
Type: Bug


Attachments (Terms of Use)

Description Robert Vazan 2018-09-11 13:53:32 UTC
I have github configured as remote repository for local mercurial repository like this:

git+ssh://git:myaccount/myrepo.git

When I run 'hg push github', I get the following error:

pushing to git+ssh://git:myaccount/myrepo.git
searching for changes
** unknown exception encountered, please report by visiting
** https://mercurial-scm.org/wiki/BugTracker
** Python 2.7.15 (default, May 16 2018, 17:50:09) [GCC 8.1.1 20180502 (Red Hat 8.1.1-1)]
** Mercurial Distributed SCM (version 4.4.2)
** Extensions loaded: hggit
Traceback (most recent call last):
  File "/usr/bin/hg", line 41, in <module>
    dispatch.run()
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 88, in run
    status = (dispatch(req) or 0) & 255
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 178, in dispatch
    ret = _runcatch(req)
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 319, in _runcatch
    return _callcatch(ui, _runcatchfunc)
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 327, in _callcatch
    return scmutil.callcatch(ui, func)
  File "/usr/lib64/python2.7/site-packages/mercurial/scmutil.py", line 154, in callcatch
    return func()
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 309, in _runcatchfunc
    return _dispatch(req)
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 1033, in _dispatch
    cmdpats, cmdoptions)
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 788, in runcommand
    ret = _runcommand(ui, options, cmd, d)
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 1041, in _runcommand
    return cmdfunc()
  File "/usr/lib64/python2.7/site-packages/mercurial/dispatch.py", line 1030, in <lambda>
    d = lambda: util.checksignature(func)(ui, *args, **strcmdopt)
  File "/usr/lib64/python2.7/site-packages/mercurial/util.py", line 1183, in check
    return func(*args, **kwargs)
  File "/usr/lib64/python2.7/site-packages/mercurial/commands.py", line 4164, in push
    opargs=opargs)
  File "/usr/lib/python2.7/site-packages/hggit/util.py", line 56, in inner
    return f(*args, **kwargs)
  File "/usr/lib/python2.7/site-packages/hggit/__init__.py", line 384, in exchangepush
    pushop.cgresult = repo.githandler.push(remote.path, revs, force)
  File "/usr/lib/python2.7/site-packages/hggit/git_handler.py", line 404, in push
    old_refs, new_refs = self.upload_pack(remote, revs, force)
  File "/usr/lib/python2.7/site-packages/hggit/git_handler.py", line 1113, in upload_pack
    progress=callback)
  File "/usr/lib64/python2.7/site-packages/dulwich/client.py", line 704, in send_pack
    ofs_delta=(CAPABILITY_OFS_DELTA in negotiated_capabilities))
TypeError: genpack() got an unexpected keyword argument 'ofs_delta'

The system is fully updated. I followed the same steps a few months ago with no error. Package versions are as follows:

$ dnf list installed | grep hg
hg-git.noarch                            0.8.11-1.fc28                 @updates 
tortoisehg.noarch                        4.4.2-3.fc28                  @fedora  

$ dnf list installed | grep dulwich
dulwich-core.x86_64                      0.19.2-1.fc28                 @updates 
python2-dulwich.x86_64                   0.19.2-1.fc28                 @updates 

This bug might be related to #1574515.

Comment 1 Petr Stodulka 2018-09-11 14:24:17 UTC
Hi Robert,
it seems that this would be the fix: https://bitbucket.org/durin42/hg-git/commits/666ab5997802fd23578092b5a8b2c402845f1c00

I would prepare testing build today in case you would be able to test it as I am constantly in busy mode.

Comment 2 Robert Vazan 2018-09-12 06:47:16 UTC
I can test in a VM this week if you can give me instructions on how to install the test build.

Comment 3 Fedora Update System 2018-09-12 07:42:54 UTC
hg-git-0.8.11-3.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-ea52573493

Comment 4 Fedora Update System 2018-09-12 07:43:00 UTC
hg-git-0.8.11-2.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-6970c9ac1b

Comment 5 Fedora Update System 2018-09-13 03:32:15 UTC
hg-git-0.8.11-3.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-ea52573493

Comment 6 Robert Vazan 2018-09-13 07:26:56 UTC
I am having trouble getting the updated package to install. I have installed nightly Fedora-29-20180912.0 in a VM and executed the following commands:

dnf config-manager --set-enabled updates-testing
dnf update
dnf install hg-git
dnf install hg-git --enablerepo=updates-testing
dnf install hg-git-0.8.11-3
dnf install hg-git-0.8.11-3.fc29
dnf install hg-git-0.8.11-3.fc29.noarch

The first two 'dnf install' commands report that package hg-git-0.8.11-2.fc29.noarch is already installed. The other 'dnf install' commands say there is no such package.

Comment 7 Fedora Update System 2018-09-13 17:51:57 UTC
hg-git-0.8.11-2.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-6970c9ac1b

Comment 8 Robert Vazan 2018-09-14 19:59:27 UTC
The updated packages finally became visible in both fc28 and fc29 repos. I have tested the fc28 package and it works perfectly. You can release it.

Comment 9 Petr Stodulka 2018-09-17 12:10:50 UTC
Hi Robert,
thanks for feedback. Once it will get enough karma or 2weeks will pass, it will be pushed into the stable repo.

Comment 10 Fedora Update System 2018-09-26 20:20:08 UTC
hg-git-0.8.11-3.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2018-09-27 02:33:39 UTC
hg-git-0.8.11-2.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.